// Start of user code Copyright
/*
 * Copyright (c) 2020 Contributors to the Eclipse Foundation
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information regarding copyright ownership.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License 2.0 which is available at
 * http://www.eclipse.org/legal/epl-2.0, or the Eclipse Distribution License 1.0
 * which is available at http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * SPDX-License-Identifier: EPL-2.0 OR BSD-3-Clause
 */
// End of user code

package org.eclipse.lyo.oslc4j.core.model;

import org.eclipse.lyo.oslc4j.core.model.OslcConstants;


// Start of user code imports
// End of user code

public interface OslcDomainConstants
{
    // Start of user code user constants
    // End of user code

    public static String OSLC_DOMAIN = "http://open-services.net/ns/core#";
    public static String OSLC_NAMSPACE = "http://open-services.net/ns/core#";
    public static String OSLC_NAMSPACE_PREFIX = "oslc";

    public static String ALLOWED_VALUES_PATH = "allowedValues";
    public static String ALLOWED_VALUES_NAMESPACE = OSLC_NAMSPACE; //namespace of the rdfs:class the resource describes
    public static String ALLOWED_VALUES_LOCALNAME = "Allowed Values"; //localName of the rdfs:class the resource describes
    public static String ALLOWED_VALUES_TYPE = ALLOWED_VALUES_NAMESPACE + ALLOWED_VALUES_LOCALNAME; //fullname of the rdfs:class the resource describes
    public static String CREATIONFACTORY_PATH = "creationFactory";
    public static String CREATIONFACTORY_NAMESPACE = OSLC_NAMSPACE; //namespace of the rdfs:class the resource describes
    public static String CREATIONFACTORY_LOCALNAME = "CreationFactory"; //localName of the rdfs:class the resource describes
    public static String CREATIONFACTORY_TYPE = CREATIONFACTORY_NAMESPACE + CREATIONFACTORY_LOCALNAME; //fullname of the rdfs:class the resource describes
    public static String DIALOG_PATH = "dialog";
    public static String DIALOG_NAMESPACE = OSLC_NAMSPACE; //namespace of the rdfs:class the resource describes
    public static String DIALOG_LOCALNAME = "Dialog"; //localName of the rdfs:class the resource describes
    public static String DIALOG_TYPE = DIALOG_NAMESPACE + DIALOG_LOCALNAME; //fullname of the rdfs:class the resource describes
    public static String DISCUSSION_PATH = "discussion";
    public static String DISCUSSION_NAMESPACE = OSLC_NAMSPACE; //namespace of the rdfs:class the resource describes
    public static String DISCUSSION_LOCALNAME = "Discussion"; //localName of the rdfs:class the resource describes
    public static String DISCUSSION_TYPE = DISCUSSION_NAMESPACE + DISCUSSION_LOCALNAME; //fullname of the rdfs:class the resource describes
    public static String PROPERTY_PATH = "property";
    public static String PROPERTY_NAMESPACE = OSLC_NAMSPACE; //namespace of the rdfs:class the resource describes
    public static String PROPERTY_LOCALNAME = "Property"; //localName of the rdfs:class the resource describes
    public static String PROPERTY_TYPE = PROPERTY_NAMESPACE + PROPERTY_LOCALNAME; //fullname of the rdfs:class the resource describes
    public static String PUBLISHER_PATH = "publisher";
    public static String PUBLISHER_NAMESPACE = OSLC_NAMSPACE; //namespace of the rdfs:class the resource describes
    public static String PUBLISHER_LOCALNAME = "Publisher"; //localName of the rdfs:class the resource describes
    public static String PUBLISHER_TYPE = PUBLISHER_NAMESPACE + PUBLISHER_LOCALNAME; //fullname of the rdfs:class the resource describes
    public static String QUERYCAPABILITY_PATH = "queryCapability";
    public static String QUERYCAPABILITY_NAMESPACE = OSLC_NAMSPACE; //namespace of the rdfs:class the resource describes
    public static String QUERYCAPABILITY_LOCALNAME = "QueryCapability"; //localName of the rdfs:class the resource describes
    public static String QUERYCAPABILITY_TYPE = QUERYCAPABILITY_NAMESPACE + QUERYCAPABILITY_LOCALNAME; //fullname of the rdfs:class the resource describes
    public static String RESOURCESHAPE_PATH = "resourceShape";
    public static String RESOURCESHAPE_NAMESPACE = OSLC_NAMSPACE; //namespace of the rdfs:class the resource describes
    public static String RESOURCESHAPE_LOCALNAME = "ResourceShape"; //localName of the rdfs:class the resource describes
    public static String RESOURCESHAPE_TYPE = RESOURCESHAPE_NAMESPACE + RESOURCESHAPE_LOCALNAME; //fullname of the rdfs:class the resource describes
    public static String SERVICE_PATH = "service";
    public static String SERVICE_NAMESPACE = OSLC_NAMSPACE; //namespace of the rdfs:class the resource describes
    public static String SERVICE_LOCALNAME = "Service"; //localName of the rdfs:class the resource describes
    public static String SERVICE_TYPE = SERVICE_NAMESPACE + SERVICE_LOCALNAME; //fullname of the rdfs:class the resource describes
    public static String SERVICEPROVIDER_PATH = "serviceProvider";
    public static String SERVICEPROVIDER_NAMESPACE = OSLC_NAMSPACE; //namespace of the rdfs:class the resource describes
    public static String SERVICEPROVIDER_LOCALNAME = "ServiceProvider"; //localName of the rdfs:class the resource describes
    public static String SERVICEPROVIDER_TYPE = SERVICEPROVIDER_NAMESPACE + SERVICEPROVIDER_LOCALNAME; //fullname of the rdfs:class the resource describes
    public static String SERVICEPROVIDERCATALOG_PATH = "serviceProviderCatalog";
    public static String SERVICEPROVIDERCATALOG_NAMESPACE = OSLC_NAMSPACE; //namespace of the rdfs:class the resource describes
    public static String SERVICEPROVIDERCATALOG_LOCALNAME = "ServiceProviderCatalog"; //localName of the rdfs:class the resource describes
    public static String SERVICEPROVIDERCATALOG_TYPE = SERVICEPROVIDERCATALOG_NAMESPACE + SERVICEPROVIDERCATALOG_LOCALNAME; //fullname of the rdfs:class the resource describes
}
