// Start of user code "Copyright Header"
/*
 * Copyright (c) 2020 Contributors to the Eclipse Foundation
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information regarding copyright ownership.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Distribution License 1.0 which is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * SPDX-License-Identifier: BSD-3-Simple
 *
 * This file is generated by Lyo Designer (https://www.eclipse.org/lyo/)
 */
// End of user code

//register an addEventListener that handles the response form the Selection DelegatedUI iframe to the parent window.
//For each of the selected OSLC resource, the function will call oslcSelectionPresentationFunction with the url and label of that resource.
function registerSelectionDUIResponseListener(iframeElement, oslcSelectionPreprocessingFunction, oslcSelectionPresentationFunction) {
    window.addEventListener('message', function (e) {
        var HEADER = "oslc-response:";
        if (e.source == iframeElement.contentWindow
                && e.data.indexOf(HEADER) == 0) {
            var message = e.data.slice(HEADER.length);
            oslcSelectionPreprocessingFunction();
            var selectedOslcResources = JSON.parse(message)["oslc:results"];
            for (var i = 0; i < selectedOslcResources.length; i++) {
                oslcSelectionPresentationFunction(selectedOslcResources[i]["rdf:resource"], selectedOslcResources[i]["oslc:label"]);
            }
        }
    }, false);
}


//register an addEventListener that handles the response form the Creation DelegatedUI iframe to the parent window.
//For the created OSLC resource, the function will call oslcCreationPresentationFunction with the url and label of that resource.
function registerCreationDUIResponseListener(iframeElement, oslcCreationPreprocessingFunction, oslcCreationPresentationFunction) {
    window.addEventListener('message', function (e) {
        var HEADER = "oslc-response:";
        if (e.source == iframeElement.contentWindow
                && e.data.indexOf(HEADER) == 0) {
            var message = e.data.slice(HEADER.length);
            oslcCreationPreprocessingFunction();
            var createdOslcResource = JSON.parse(message)["oslc:results"];
            oslcCreationPresentationFunction(createdOslcResource[0]["rdf:resource"], createdOslcResource[0]["oslc:label"]);
        }
    }, false);
}

