// Start of user code Copyright
/*
 * Copyright (c) 2020 Contributors to the Eclipse Foundation
 *
 * See the NOTICE file(s) distributed with this work for additional
 * information regarding copyright ownership.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Distribution License 1.0 which is available at
 * http://www.eclipse.org/org/documents/edl-v10.php.
 *
 * SPDX-License-Identifier: BSD-3-Simple
 *
 * This file is generated by Lyo Designer (https://www.eclipse.org/lyo/)
 */
// End of user code

package cz.vutbr.fit.group.verifit.oslc.compilation.services;

import java.io.IOException;
import java.io.PrintWriter;
import java.net.URI;
import java.net.URISyntaxException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.text.SimpleDateFormat;
import java.text.ParseException;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.Consumes;
import javax.ws.rs.DELETE;
import javax.ws.rs.FormParam;
import javax.ws.rs.GET;
import javax.ws.rs.HeaderParam;
import javax.ws.rs.POST;
import javax.ws.rs.PUT;
import javax.ws.rs.Path;
import javax.ws.rs.PathParam;
import javax.ws.rs.Produces;
import javax.ws.rs.QueryParam;
import javax.ws.rs.WebApplicationException;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.MultivaluedMap;
import javax.ws.rs.core.Response;
import javax.ws.rs.core.Response.Status;
import javax.ws.rs.core.UriInfo;
import javax.ws.rs.core.UriBuilder;

import org.apache.wink.json4j.JSONException;
import org.apache.wink.json4j.JSONObject;
import org.eclipse.lyo.oslc4j.provider.json4j.JsonHelper;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.eclipse.lyo.oslc4j.core.OSLC4JUtils;
import org.eclipse.lyo.oslc4j.core.annotation.OslcCreationFactory;
import org.eclipse.lyo.oslc4j.core.annotation.OslcDialog;
import org.eclipse.lyo.oslc4j.core.annotation.OslcDialogs;
import org.eclipse.lyo.oslc4j.core.annotation.OslcQueryCapability;
import org.eclipse.lyo.oslc4j.core.annotation.OslcService;
import org.eclipse.lyo.oslc4j.core.model.Compact;
import org.eclipse.lyo.oslc4j.core.model.OslcConstants;
import org.eclipse.lyo.oslc4j.core.model.OslcMediaType;
import org.eclipse.lyo.oslc4j.core.model.Preview;
import org.eclipse.lyo.oslc4j.core.model.ServiceProvider;
import org.eclipse.lyo.oslc4j.core.model.Link;
import org.eclipse.lyo.oslc4j.core.model.AbstractResource;

import cz.vutbr.fit.group.verifit.oslc.compilation.VeriFitCompilationManager;
import cz.vutbr.fit.group.verifit.oslc.compilation.VeriFitCompilationConstants;
import org.eclipse.lyo.oslc.domains.auto.Oslc_autoDomainConstants;
import cz.vutbr.fit.group.verifit.oslc.compilation.servlet.ServiceProviderCatalogSingleton;
import org.eclipse.lyo.oslc.domains.auto.AutomationResult;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

// Start of user code imports
// End of user code

// Start of user code pre_class_code
// End of user code
@Path("resources")
@Api(value = "Web Service for {" + Oslc_autoDomainConstants.AUTOMATIONRESULT_LOCALNAME + "}")
public class AutomationResults
{
    @Context private HttpServletRequest httpServletRequest;
    @Context private HttpServletResponse httpServletResponse;
    @Context private UriInfo uriInfo;

    private static final Logger log = LoggerFactory.getLogger(AutomationResults.class);

    // Start of user code class_attributes
    // End of user code

    // Start of user code class_methods
    // End of user code

    public AutomationResults()
    {
        super();
    }

    private void addCORSHeaders (final HttpServletResponse httpServletResponse) {
        //UI preview can be blocked by CORS policy.
        //add select CORS headers to every response that is embedded in an iframe.
        httpServletResponse.addHeader("Access-Control-Allow-Origin", "*");
        httpServletResponse.addHeader("Access-Control-Allow-Methods", "GET, OPTIONS, HEAD");
        httpServletResponse.addHeader("Access-Control-Allow-Headers", "origin, content-type, accept, authorization");
        httpServletResponse.addHeader("Access-Control-Allow-Credentials", "true");
    }

    @GET
    @Path("automationResults/{id}")
    @Produces({OslcMediaType.APPLICATION_RDF_XML, OslcMediaType.APPLICATION_JSON_LD, OslcMediaType.TEXT_TURTLE, OslcMediaType.APPLICATION_XML, OslcMediaType.APPLICATION_JSON})
    @ApiOperation(
        value = "GET for resources of type {'" + Oslc_autoDomainConstants.AUTOMATIONRESULT_LOCALNAME + "'}",
        notes = "GET for resources of type {'" + "<a href=\"" + Oslc_autoDomainConstants.AUTOMATIONRESULT_TYPE + "\">" + Oslc_autoDomainConstants.AUTOMATIONRESULT_LOCALNAME + "</a>" + "'}" +
            ", with respective resource shapes {'" + "<a href=\"" + "../services/" + OslcConstants.PATH_RESOURCE_SHAPES + "/" + Oslc_autoDomainConstants.AUTOMATIONRESULT_PATH + "\">" + Oslc_autoDomainConstants.AUTOMATIONRESULT_LOCALNAME + "</a>" + "'}",
        produces = OslcMediaType.APPLICATION_RDF_XML + ", " + OslcMediaType.APPLICATION_XML + ", " + OslcMediaType.APPLICATION_JSON + ", " + OslcMediaType.TEXT_TURTLE + ", " + MediaType.TEXT_HTML + ", " + OslcMediaType.APPLICATION_X_OSLC_COMPACT_XML
    )
    public AutomationResult getAutomationResult(
                @PathParam("id") final String id
        ) throws IOException, ServletException, URISyntaxException
    {
        // Start of user code getResource_init
        // End of user code

        final AutomationResult aAutomationResult = VeriFitCompilationManager.getAutomationResult(httpServletRequest, id);

        if (aAutomationResult != null) {
            // Start of user code getAutomationResult
            // End of user code
            httpServletResponse.setHeader("ETag", VeriFitCompilationManager.getETagFromAutomationResult(aAutomationResult));
            httpServletResponse.addHeader(VeriFitCompilationConstants.HDR_OSLC_VERSION, VeriFitCompilationConstants.OSLC_VERSION_V2);
            return aAutomationResult;
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

    @GET
    @Path("automationResults/{id}")
    @Produces({ MediaType.TEXT_HTML })
    @ApiOperation(
        value = "GET for resources of type {'" + Oslc_autoDomainConstants.AUTOMATIONRESULT_LOCALNAME + "'}",
        notes = "GET for resources of type {'" + "<a href=\"" + Oslc_autoDomainConstants.AUTOMATIONRESULT_TYPE + "\">" + Oslc_autoDomainConstants.AUTOMATIONRESULT_LOCALNAME + "</a>" + "'}" +
            ", with respective resource shapes {'" + "<a href=\"" + "../services/" + OslcConstants.PATH_RESOURCE_SHAPES + "/" + Oslc_autoDomainConstants.AUTOMATIONRESULT_PATH + "\">" + Oslc_autoDomainConstants.AUTOMATIONRESULT_LOCALNAME + "</a>" + "'}",
        produces = OslcMediaType.APPLICATION_RDF_XML + ", " + OslcMediaType.APPLICATION_XML + ", " + OslcMediaType.APPLICATION_JSON + ", " + OslcMediaType.TEXT_TURTLE + ", " + MediaType.TEXT_HTML + ", " + OslcMediaType.APPLICATION_X_OSLC_COMPACT_XML
    )
    public void getAutomationResultAsHtml(
        @PathParam("id") final String id
        ) throws ServletException, IOException, URISyntaxException
    {
        // Start of user code getAutomationResultAsHtml_init
        // End of user code

        final AutomationResult aAutomationResult = VeriFitCompilationManager.getAutomationResult(httpServletRequest, id);

        if (aAutomationResult != null) {
            httpServletRequest.setAttribute("aAutomationResult", aAutomationResult);
            // Start of user code getAutomationResultAsHtml_setAttributes
            // End of user code

            RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/cz/vutbr/fit/group/verifit/oslc/compilation/automationresult.jsp");
            rd.forward(httpServletRequest,httpServletResponse);
            return;
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

    @GET
    @Path("automationResults/{id}")
    @Produces({OslcMediaType.APPLICATION_X_OSLC_COMPACT_XML})
    @ApiOperation(
        value = "GET for resources of type {'" + Oslc_autoDomainConstants.AUTOMATIONRESULT_LOCALNAME + "'}",
        notes = "GET for resources of type {'" + "<a href=\"" + Oslc_autoDomainConstants.AUTOMATIONRESULT_TYPE + "\">" + Oslc_autoDomainConstants.AUTOMATIONRESULT_LOCALNAME + "</a>" + "'}" +
            ", with respective resource shapes {'" + "<a href=\"" + "../services/" + OslcConstants.PATH_RESOURCE_SHAPES + "/" + Oslc_autoDomainConstants.AUTOMATIONRESULT_PATH + "\">" + Oslc_autoDomainConstants.AUTOMATIONRESULT_LOCALNAME + "</a>" + "'}",
        produces = OslcMediaType.APPLICATION_RDF_XML + ", " + OslcMediaType.APPLICATION_XML + ", " + OslcMediaType.APPLICATION_JSON + ", " + OslcMediaType.TEXT_TURTLE + ", " + MediaType.TEXT_HTML + ", " + OslcMediaType.APPLICATION_X_OSLC_COMPACT_XML
    )
    public Compact getAutomationResultCompact(
        @PathParam("id") final String id
        ) throws ServletException, IOException, URISyntaxException
    {
        String iconUri = OSLC4JUtils.getPublicURI() + "/images/ui_preview_icon.gif";
        String smallPreviewHintHeight = "10em";
        String smallPreviewHintWidth = "45em";
        String largePreviewHintHeight = "20em";
        String largePreviewHintWidth = "45em";

        // Start of user code getAutomationResultCompact_init
        //TODO: adjust the preview height & width values from the default values provided above.
        // End of user code

        final AutomationResult aAutomationResult = VeriFitCompilationManager.getAutomationResult(httpServletRequest, id);

        if (aAutomationResult != null) {
            final Compact compact = new Compact();

            compact.setAbout(aAutomationResult.getAbout());
            compact.setTitle(aAutomationResult.toString());

            compact.setIcon(new URI(iconUri));

            //Create and set attributes for OSLC preview resource
            final Preview smallPreview = new Preview();
            smallPreview.setHintHeight(smallPreviewHintHeight);
            smallPreview.setHintWidth(smallPreviewHintWidth);
            smallPreview.setDocument(UriBuilder.fromUri(aAutomationResult.getAbout()).path("smallPreview").build());
            compact.setSmallPreview(smallPreview);

            final Preview largePreview = new Preview();
            largePreview.setHintHeight(largePreviewHintHeight);
            largePreview.setHintWidth(largePreviewHintWidth);
            largePreview.setDocument(UriBuilder.fromUri(aAutomationResult.getAbout()).path("largePreview").build());
            compact.setLargePreview(largePreview);

            httpServletResponse.addHeader(VeriFitCompilationConstants.HDR_OSLC_VERSION, VeriFitCompilationConstants.OSLC_VERSION_V2);
            addCORSHeaders(httpServletResponse);
            return compact;
        }
        throw new WebApplicationException(Status.NOT_FOUND);
    }

    @GET
    @Path("automationResults/{id}/smallPreview")
    @Produces({ MediaType.TEXT_HTML })
    public void getAutomationResultAsHtmlSmallPreview(
        @PathParam("id") final String id
        ) throws ServletException, IOException, URISyntaxException
    {
        // Start of user code getAutomationResultAsHtmlSmallPreview_init
        // End of user code

        final AutomationResult aAutomationResult = VeriFitCompilationManager.getAutomationResult(httpServletRequest, id);

        if (aAutomationResult != null) {
            httpServletRequest.setAttribute("aAutomationResult", aAutomationResult);
            // Start of user code getAutomationResultAsHtmlSmallPreview_setAttributes
            // End of user code

            RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/cz/vutbr/fit/group/verifit/oslc/compilation/automationresultsmallpreview.jsp");
            httpServletResponse.addHeader(VeriFitCompilationConstants.HDR_OSLC_VERSION, VeriFitCompilationConstants.OSLC_VERSION_V2);
            addCORSHeaders(httpServletResponse);
            rd.forward(httpServletRequest, httpServletResponse);
            return;
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }

    @GET
    @Path("automationResults/{id}/largePreview")
    @Produces({ MediaType.TEXT_HTML })
    public void getAutomationResultAsHtmlLargePreview(
        @PathParam("id") final String id
        ) throws ServletException, IOException, URISyntaxException
    {
        // Start of user code getAutomationResultAsHtmlLargePreview_init
        // End of user code

        final AutomationResult aAutomationResult = VeriFitCompilationManager.getAutomationResult(httpServletRequest, id);

        if (aAutomationResult != null) {
            httpServletRequest.setAttribute("aAutomationResult", aAutomationResult);
            // Start of user code getAutomationResultAsHtmlLargePreview_setAttributes
            // End of user code

            RequestDispatcher rd = httpServletRequest.getRequestDispatcher("/cz/vutbr/fit/group/verifit/oslc/compilation/automationresultlargepreview.jsp");
            httpServletResponse.addHeader(VeriFitCompilationConstants.HDR_OSLC_VERSION, VeriFitCompilationConstants.OSLC_VERSION_V2);
            addCORSHeaders(httpServletResponse);
            rd.forward(httpServletRequest, httpServletResponse);
            return;
        }

        throw new WebApplicationException(Status.NOT_FOUND);
    }
    @DELETE
    @Path("automationResults/{id}")
    @ApiOperation(
        value = "DELETE for resources of type {'" + Oslc_autoDomainConstants.AUTOMATIONRESULT_LOCALNAME + "'}",
        notes = "DELETE for resources of type {'" + "<a href=\"" + Oslc_autoDomainConstants.AUTOMATIONRESULT_TYPE + "\">" + Oslc_autoDomainConstants.AUTOMATIONRESULT_LOCALNAME + "</a>" + "'}" +
            ", with respective resource shapes {'" + "<a href=\"" + "../services/" + OslcConstants.PATH_RESOURCE_SHAPES + "/" + Oslc_autoDomainConstants.AUTOMATIONRESULT_PATH + "\">" + Oslc_autoDomainConstants.AUTOMATIONRESULT_LOCALNAME + "</a>" + "'}",
        produces = OslcMediaType.APPLICATION_RDF_XML + ", " + OslcMediaType.APPLICATION_XML + ", " + OslcMediaType.APPLICATION_JSON + ", " + OslcMediaType.TEXT_TURTLE + ", " + MediaType.TEXT_HTML + ", " + OslcMediaType.APPLICATION_X_OSLC_COMPACT_XML
    )
    public Response deleteAutomationResult(
                @PathParam("id") final String id
        ) throws IOException, ServletException, URISyntaxException
    {
        // Start of user code deleteAutomationResult_init
        // End of user code
        final AutomationResult aResource = VeriFitCompilationManager.getAutomationResult(httpServletRequest, id);

        if (aResource != null) {
            // Start of user code deleteAutomationResult
            // End of user code
            boolean deleted = VeriFitCompilationManager.deleteAutomationResult(httpServletRequest, id);
            if (deleted)
                return Response.ok().header(VeriFitCompilationConstants.HDR_OSLC_VERSION, VeriFitCompilationConstants.OSLC_VERSION_V2).build();
            else
                throw new WebApplicationException(Status.INTERNAL_SERVER_ERROR);
        }
        throw new WebApplicationException(Status.NOT_FOUND);
    }

    @PUT
    @Path("automationResults/{id}")
    @Consumes({OslcMediaType.APPLICATION_RDF_XML, OslcMediaType.APPLICATION_JSON_LD, OslcMediaType.TEXT_TURTLE, OslcMediaType.APPLICATION_XML, OslcMediaType.APPLICATION_JSON })
    @ApiOperation(
        value = "PUT for resources of type {'" + Oslc_autoDomainConstants.AUTOMATIONRESULT_LOCALNAME + "'}",
        notes = "PUT for resources of type {'" + "<a href=\"" + Oslc_autoDomainConstants.AUTOMATIONRESULT_TYPE + "\">" + Oslc_autoDomainConstants.AUTOMATIONRESULT_LOCALNAME + "</a>" + "'}" +
            ", with respective resource shapes {'" + "<a href=\"" + "../services/" + OslcConstants.PATH_RESOURCE_SHAPES + "/" + Oslc_autoDomainConstants.AUTOMATIONRESULT_PATH + "\">" + Oslc_autoDomainConstants.AUTOMATIONRESULT_LOCALNAME + "</a>" + "'}",
        produces = OslcMediaType.APPLICATION_RDF_XML + ", " + OslcMediaType.APPLICATION_XML + ", " + OslcMediaType.APPLICATION_JSON + ", " + OslcMediaType.TEXT_TURTLE + ", " + MediaType.TEXT_HTML + ", " + OslcMediaType.APPLICATION_X_OSLC_COMPACT_XML
    )
    public Response updateAutomationResult(
            @HeaderParam("If-Match") final String eTagHeader,
            @PathParam("id") final String id ,
            final AutomationResult aResource
        ) throws IOException, ServletException
    {
        // Start of user code updateAutomationResult_init
        // End of user code
        final AutomationResult originalResource = VeriFitCompilationManager.getAutomationResult(httpServletRequest, id);

        if (originalResource != null) {
            final String originalETag = VeriFitCompilationManager.getETagFromAutomationResult(originalResource);

            if ((eTagHeader == null) || (originalETag.equals(eTagHeader))) {
                // Start of user code updateAutomationResult
                // End of user code
                final AutomationResult updatedResource = VeriFitCompilationManager.updateAutomationResult(httpServletRequest, aResource, id);
                httpServletResponse.setHeader("ETag", VeriFitCompilationManager.getETagFromAutomationResult(updatedResource));
                return Response.ok().header(VeriFitCompilationConstants.HDR_OSLC_VERSION, VeriFitCompilationConstants.OSLC_VERSION_V2).build();
            }
            else {
                throw new WebApplicationException(Status.PRECONDITION_FAILED);
            }
        }
        else {
            throw new WebApplicationException(Status.NOT_FOUND);
        }
    }

}
