<%--To avoid the overriding of any manual code changes upon subsequent code generations, disable "Generate JSP Files" option in the Adaptor model.--%>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<!DOCTYPE html>
<%--
 Copyright (c) 2020 Contributors to the Eclipse Foundation
 
 See the NOTICE file(s) distributed with this work for additional
 information regarding copyright ownership.
 
 This program and the accompanying materials are made available under the
 terms of the Eclipse Distribution License 1.0 which is available at
 http://www.eclipse.org/org/documents/edl-v10.php.
 
 SPDX-License-Identifier: BSD-3-Simple

 This file is generated by Lyo Designer (https://www.eclipse.org/lyo/)
--%>

<%@page import="org.eclipse.lyo.oslc4j.core.model.ServiceProvider" %>
<%@ page contentType="text/html" language="java" pageEncoding="UTF-8" %>
<%
  String creationDialogUri = request.getParameter("creationUri");
  creationDialogUri += "#oslc-core-postMessage-1.0";
%>
<html>
<head>
  <title>Creation Dialog client</title>

  <link href="<c:url value="/static/css/bootstrap-4.0.0-beta.min.css"/>" rel="stylesheet">
  <link href="<c:url value="/static/css/adaptor.css"/>" rel="stylesheet">

  <script src="<c:url value="/static/js/jquery-3.2.1.min.js"/>"></script>
  <script src="<c:url value="/static/js/popper-1.11.0.min.js"/>"></script>
  <script src="<c:url value="/static/js/bootstrap-4.0.0-beta.min.js"/>"></script>
  <script src="<c:url value="/static/js/delegated-ui-helper.js"/>"></script>
  <script src="<c:url value="/static/js/ui-preview-helper.js"/>"></script>
</head>
<body>

  <nav class="navbar navbar-expand-lg sticky-top navbar-light bg-light">
    <div class="container">
      <ul class="navbar-nav mr-auto">
        <li class="nav-item"><a class="nav-link" href="<c:url value="/"/>"><%= application.getServletContextName() %></a></li>
        <li class="nav-item"><a class="nav-link" href="<c:url value="/services/catalog/singleton"/>">Service Provider Catalog</a></li>
        <li class="nav-item"><a class="nav-link" href="<c:url value="/swagger-ui/index.jsp"/>">Swagger UI</a></li>
      </ul>
    </div>
  </nav>

<div class="container">

  <div class="page-header">
    <h1>Creation Dialog sample client</h1>
    <p>Use this sample code (html, javascript) to build your own interactions with OSLC Delegated UIs.</p>
  </div>

  <div class="row">
    <div class="col-md-6 col-md-offset-3">
      <div class="panel panel-primary">
        <div class="panel-heading">Creation Dialog iframe for:</div>
        <div class="panel-footer">
          <p><em style="word-wrap:break-word;"><%= creationDialogUri %></em></p>
        </div>
        <div class="panel-body">
          <iframe src="<%= creationDialogUri %>" id="delegatedUI"></iframe>
        </div>
      </div>
    </div>
  </div>

  <div class="row">
    <div class="col-md-6 col-md-offset-3">
      <div class="panel panel-success">
        <div class="panel-heading">Creation Dialog results</div>
        <div class="panel-body" id="results">
            <ul></ul>
        </div>
      </div>
    </div>
  </div>

</div>

<footer class="footer">
  <div class="container">
    <p class="text-muted">
      OSLC Adaptor was generated using <a href="http://eclipse.org/lyo">Eclipse Lyo</a>.
    </p>
  </div>
</footer>

<script type="text/javascript">
    $(function () {
        registerCreationDUIResponseListener(document.getElementById("delegatedUI"), resetPreviousCreation, presentOslcCreation);

        function presentOslcCreation(resourceUrl, resourceLabel) {
            var displayContainer = document.getElementById("results");
            var hyperlinkElement = document.createElement('a');  
            var link = document.createTextNode(resourceLabel); 
            hyperlinkElement.appendChild(link);  
            hyperlinkElement.title = resourceLabel;
            hyperlinkElement.href = resourceUrl;
            hyperlinkElement.className = 'oslc-resource-link';
            var li = document.createElement("LI");
            li.appendChild(hyperlinkElement); 
            document.querySelector('#results ul').appendChild(li);
            setupUiPreviewOnPopover($("a.oslc-resource-link"));
        }

        function resetPreviousCreation() {
            var resultsUl = document.querySelector('#results ul')
            while(resultsUl.hasChildNodes()) {
                resultsUl.removeChild(resultsUl.lastChild)
            }
        }
    });
</script>
</body>
</html>
